package core

import (
	"fmt"

	"git.akyoto.dev/cli/q/src/expression"
	"git.akyoto.dev/cli/q/src/types"
	"git.akyoto.dev/cli/q/src/x86"
)

// CallExtern calls an external function.
func (f *Function) CallExtern(fn *Function, parameters []*expression.Expression) ([]types.Type, error) {
	f.DLLs = f.DLLs.Append(fn.Package, fn.Name)
	registers := x86.WindowsInputRegisters[:len(parameters)]
	err := f.BeforeCall(fn, parameters, registers)

	if err != nil {
		return nil, err
	}

	f.DLLCall(fmt.Sprintf("%s.%s", fn.Package, fn.Name))
	return fn.OutputTypes, nil
}
